"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NodeFile = void 0;
var form_data_1 = __importDefault(require("form-data"));
var url_join_1 = __importDefault(require("url-join"));
var axios_1 = __importDefault(require("axios"));
var http_status_codes_1 = require("http-status-codes");
var fs_1 = __importDefault(require("fs"));
var etherdata_sdk_common_1 = require("@etherdata-blockchain/etherdata-sdk-common");
/**
 * Node js file api
 */
var NodeFile = /** @class */ (function () {
    function NodeFile(url) {
        this.url = url;
    }
    NodeFile.prototype.downloadFile = function (_a) {
        var fileId = _a.fileId, downloadPath = _a.downloadPath;
        return __awaiter(this, void 0, void 0, function () {
            var reqURL, fileWriter, response;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        reqURL = (0, url_join_1.default)(this.url, etherdata_sdk_common_1.URL.download, fileId);
                        fs_1.default.openSync(downloadPath, "w");
                        fileWriter = fs_1.default.createWriteStream(downloadPath);
                        return [4 /*yield*/, axios_1.default.get(reqURL, { responseType: "stream" })];
                    case 1:
                        response = _b.sent();
                        response.data.pipe(fileWriter);
                        return [2 /*return*/];
                }
            });
        });
    };
    NodeFile.prototype.uploadFile = function (file, errorOnExist) {
        if (errorOnExist === void 0) { errorOnExist = false; }
        return __awaiter(this, void 0, void 0, function () {
            var formData, uploadObject, reqURL, request;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        formData = new form_data_1.default();
                        uploadObject = file.toUploadFile();
                        formData.append("file", uploadObject.file);
                        formData.append("days", uploadObject.days);
                        reqURL = (0, url_join_1.default)(this.url, etherdata_sdk_common_1.URL.upload);
                        return [4 /*yield*/, axios_1.default.post(reqURL, formData, {
                                headers: __assign({}, formData.getHeaders()),
                            })];
                    case 1:
                        request = _a.sent();
                        if (request.status === http_status_codes_1.StatusCodes.OK) {
                            if (request.data.data.isExist && errorOnExist) {
                                throw new Error("This file already exist");
                            }
                            return [2 /*return*/, request.data.data.afid];
                        }
                        throw new Error("Server returns a not ok status " + request.status);
                }
            });
        });
    };
    return NodeFile;
}());
exports.NodeFile = NodeFile;
//# sourceMappingURL=file.js.map